﻿

Public Class frmStackSim
    Dim Stackpointer As Integer = 0
    Const MAXSTACK = 4

    Private Sub txtPushValue_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtPushValue.TextChanged
        cmdPush.Text = "Push " + txtPushValue.Text
        cmdPush.Enabled = Len(cmdPush.Text) > 0   'disable push while box is empty!

    End Sub

    Private Sub cmdPush_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdPush.Click
        If txtPushValue.Text = "" Then Exit Sub 'empty value? 
        If Stackpointer = MAXSTACK Then         'would overflow?
            MsgBox("Stack overflow prevented")
            Exit Sub
        End If

        'MsgBox("Pushing " & txtPushValue.Text)

        box.Items.Add(txtPushValue.Text)     'push!
        txtPushValue.Text = ""          'clear box

        Stackpointer += 1               'update SP 
        txtTop.Text = Stackpointer      'show SP to the human
        box.Refresh()
    End Sub


    Private Sub cmdPop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdPop.Click
        If Stackpointer = 0 Then
            MsgBox("Prevented stack underflow")
            Exit Sub
        End If
        Stackpointer -= 1                 'go back to top item
        MsgBox("POPPED " & box.Items(Stackpointer))     'be informative

        box.Items.RemoveAt(Stackpointer)                  'take item off stack
        txtTop.Text = Stackpointer      'show SP to the human
        box.Refresh()
    End Sub

    Private Sub cmdExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdExit.Click
        End
    End Sub

End Class
